<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title>ItemView</title>
</head>
<body>
    <form id="Main" runat="server" />
    <!-- ScriptManager -->
    <atlas:ScriptManager runat="server" ID="scriptManager" />
    
    <!-- Element for ItemView (container) -->
    <div id="detailsView">
    </div>
    
    <!-- Navigators -->
    <input type="button" id="previousButton" value="<" title="Go to previous row" />
    <span id="rowIndexLabel"></span>
    <input id="nextButton" type="button" value=">" title="Go to next row" />
    |
    
    <!-- Commands -->
    <input type="button" id="addButton" value="New" title="Create a new row" />
    <input type="button" id="delButton" value="Delete" title="Delete the current row" />
    |
    <input type="button" id="saveButton" value="Save" title="Save all pending changes" />
    <input type="button" id="refreshButton" value="Refresh" title="Discard pending changes and get the latest data from the server" />
    
    <!-- Layout Elements -->
    <div style="visibility: hidden; display: none">
        <div id="detailsTemplate">
            Name:
            <input id="nameField" size="30" /><br />
            Description:<br />
            <textarea id="descriptionField" rows="4" cols="40"></textarea><br />
        </div>
        <div id="emptyTemplate">
            Getting Data...
        </div>
    </div>

    <script type="text/xml-script">
        <page xmlns:script="http://schemas.microsoft.com/xml-script/2005">
            <components>
                <dataSource id="dataSource" serviceURL="MyDataService.asmx" autoLoad="true" />
                
                <itemView id="detailsView">
                    <bindings>
                        <binding dataContext="dataSource" dataPath="data" property="data"/>
                        <binding dataContext="dataSource" dataPath="isReady" property="enabled"/>
                    </bindings>
                    <itemTemplate>
                        <template layoutElement="detailsTemplate">
                            <textBox id="nameField">
                                <bindings>
                                    <binding dataPath="Name" property="text" direction="InOut"/>
                                </bindings>
                            </textBox>
                            <textBox id="descriptionField">
                                <bindings>
                                    <binding dataPath="Description" property="text" direction="InOut"/>
                                </bindings>
                            </textBox>
                        </template>
                    </itemTemplate>
                    <emptyTemplate>
                        <template layoutElement="emptyTemplate" />
                    </emptyTemplate>
                </itemView>
                
                <button id="previousButton">
                    <bindings>
                        <binding dataContext="detailsView" dataPath="canMovePrevious" property="enabled"/>
                    </bindings>
                    <click>
                        <invokeMethod target="detailsView" method="movePrevious" />
                    </click>
                </button>
                
                <label id="rowIndexLabel">
                    <bindings>
                        <binding dataContext="detailsView" dataPath="dataIndex" property="text" transform="Add" />
                    </bindings>
                </label>
                
                <button id="nextButton">
                    <bindings>
                        <binding dataContext="detailsView" dataPath="canMoveNext" property="enabled"/>
                    </bindings>
                    <click>
                        <invokeMethod target="detailsView" method="moveNext" />
                    </click>
                </button>
                
                <button id="addButton">
                    <bindings>
                        <binding dataContext="dataSource" dataPath="isReady" property="enabled"/>
                    </bindings>
                    <click>
                        <invokeMethod target="detailsView" method="addItem" />
                    </click>
                </button>
                
                <button id="delButton">
                    <bindings>
                        <binding dataContext="dataSource" dataPath="isReady" property="enabled"/>
                    </bindings>
                    <click>
                        <invokeMethod target="detailsView" method="deleteCurrentItem" />
                    </click>
                </button>
                
                <button id="saveButton">
                    <bindings>
                        <binding dataContext="dataSource" dataPath="isDirtyAndReady" property="enabled"/>
                    </bindings>
                    <click>
                        <invokeMethod target="dataSource" method="save" />
                    </click>
                </button>
                
                <button id="refreshButton">
                    <bindings>
                        <binding dataContext="dataSource" dataPath="isReady" property="enabled"/>
                    </bindings>
                    <click>
                        <invokeMethod target="dataSource" method="load" />
                    </click>
                </button>
                
            </components>
        </page>
    </script>

</body>
</html>
